function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useState } from 'react';
const DisplayErrorCtx = /*#__PURE__*/React.createContext(false);
const CustomForm = ({
  children,
  onSubmit = () => {},
  submitLabel = 'Valider',
  cancelLabel = 'Annuler',
  className = '',
  disabled = false,
  isLoading = false,
  onCancel = null,
  errorMessage = null,
  isFormValid = true,
  ...props
}, ref) => {
  const [displayError, setDisplayError] = useState(false);
  const [submitError, setSubmitError] = useState(null);
  const submit = e => {
    e.preventDefault();
    !displayError && setDisplayError(true);
    if (isFormValid) {
      onSubmit(e).catch(e => console.log(e));
    }
  };
  return /*#__PURE__*/React.createElement(DisplayErrorCtx.Provider, {
    value: displayError
  }, /*#__PURE__*/React.createElement("form", _extends({
    onSubmit: submit,
    className: className
  }, props, {
    ref: ref
  }), children, displayError && !isFormValid && errorMessage != null && /*#__PURE__*/React.createElement("p", {
    className: "informations danger"
  }, errorMessage), /*#__PURE__*/React.createElement("div", {
    className: "form-buttons-container"
  }, /*#__PURE__*/React.createElement("button", {
    disabled: disabled || isLoading,
    className: `button button-uca-blue spaced-inline ${(disabled || isLoading) && 'disabled'}`
  }, /*#__PURE__*/React.createElement("span", null, submitLabel), isLoading && /*#__PURE__*/React.createElement("div", {
    className: "spinner-border spinner-border-sm",
    role: "status"
  })), onCancel != null && /*#__PURE__*/React.createElement("button", {
    className: "button button-uca-beige",
    type: "button",
    onClick: onCancel
  }, cancelLabel), submitError != null && /*#__PURE__*/React.createElement("p", {
    className: "informations"
  }, "Une erreur est survenue : ", submitError))));
};
export { DisplayErrorCtx };
export default /*#__PURE__*/React.forwardRef(CustomForm);